#!/bin/sh -eu

# Find all system executable files that are not stored in dirs listed in
# EXCLUDED_DIRS_LIST_PATH file and write their absolute paths into
# WHITE_LIST_PATH file

WHITE_LIST_PATH="/etc/control++/white_list"
EXCLUDED_DIRS_LIST_PATH="/etc/control++/excluded_from_white_list"

EXCLUDED_DIRS=`cat $EXCLUDED_DIRS_LIST_PATH`

echo "" > "$WHITE_LIST_PATH"

for dir in /*; do
	IS_EXCLUDED=0
	for ecluded_dir in $EXCLUDED_DIRS; do
		if [ "$dir" = "$ecluded_dir" ]; then
			IS_EXCLUDED=1
			break
		fi
	done
	if [ "$IS_EXCLUDED" -eq 1 ]; then
		continue
	fi
	find "$dir" -type f -executable >> "$WHITE_LIST_PATH"
done
